"============================================================================
"File:        vcs.vim
"Description: Syntax checking plugin for syntastic
"Maintainer:  Psidium <psiidium at gmail dot com>
"License:     The MIT License
"============================================================================

if exists('g:loaded_syntastic_verilog_vcs_checker')
    finish
endif
let g:loaded_syntastic_verilog_vcs_checker = 1

let s:save_cpo = &cpo
set cpo&vim

function! SyntaxCheckers_verilog_vcs_GetLocList() dict
    let makeprg = self.makeprgBuild({
        \ 'args_before': '-t null',
        \ 'args': '-full64' })

" VCS Error Format 1 
" --------------------------------------
" Error-[SE] Syntax error
"   Following verilog source has syntax error :
"   "test.sv", 7: token is ')'
"      );
"       ^

    let errorformat =
	\ '%EError-%m,' .
	\ '%C,' . 
	\ '%C\ \ "%f"\,\ %l:%m,' .
	\ '%C\ \ %m,' .
	\ '%Z%p^,' .
	\ '%EError-%m,' .
	\ '%C%f\,\ %l,' .
	\ '%C\ \ %m,' .
	\ '%C\ \ %m,' .
	\ '%Z\ \ %m'


" VCS Error Format 1 
" --------------------------------------
" Error-[IBLHS-NT] Illegal behavioral left hand side
" test.sv, 11
"   Net type cannot be used on the left side of this assignment.
"   The offending expression is : do
"   Source info: do <= 1'b0;

"    let errorformat +=
" 	\ '%EError-%m,' .
" 	\ '%C%f\,\ %l,' .
" 	\ '%C\ \ %m,' .
" 	\ '%C\ \ %m,' .
" 	\ '%Z\ \ %m'





"    let errorformat =
" 	\ '%EError-%m,' .
" 	\ '%C%f\,\ %l,' .
" 	\ '%C\ \ "%f"\,\ %l:%m,' .
" 	\ '%C\ \ %m,' .
" 	\ '%Z%p^'

    return SyntasticMake({'makeprg': makeprg, 'errorformat': errorformat})
endfunction

call g:SyntasticRegistry.CreateAndRegisterChecker({
    \ 'filetype': 'verilog',
    \ 'name': 'vcs'})

let &cpo = s:save_cpo
unlet s:save_cpo

" vim: set sw=4 sts=4 et fdm=marker:
